# Scotty TNG - ping/snmp based realtime network monitoring
#
# $Id: notify.rb 126 2008-10-04 15:12:13Z liske $
#
# Authors:
#   Thomas Liske <liske@ibh.de>
#   Andre Ellguth <ellguth@ibh.de>
#
# Copyright Holder:
#   2008 (C) IBH IT-Service GmbH [http://www.ibh.de/]
#
# License:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this package; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#

require 'sdl'

class Notify
    @@sdl_audio = true

    def self._notification(action, status, color, msg)
	action.each{|ac|
	    attr = ac[1]

	    begin
		eval Client.getCmds[ac[0]]
	    rescue
		Logger.logtxt("Error running action command '#{ac[0]}': #{$!}")
	    end
	}
    end

    def self.notification(action, interval, status, color, msg)
	_notification(action, status, color, msg)
	if (interval > 0) then
	    return Gtk.timeout_add(interval*1000) { _notification(action, status, color, msg) }
	else
	    return 0
	end
    end

    def self.terminate(id)
	Gtk.timeout_remove(id)
    end

    def self.playSound(fn)
	return unless @@sdl_audio

	SDL::Mixer.playChannel(0, SDL::Mixer::Wave.load(fn), 0)
    end

    def self.muteSound(mute)
	if mute then
	    SDL::Mixer.set_volume(-1, 0)
	else
	    SDL::Mixer.set_volume(-1, 128)
	end
    end

    def self.init
	begin
	    SDL::init(SDL::INIT_AUDIO)
	    SDL::Mixer.open
	rescue
	    Logger.logtxt("No SDL audio available: #{$!}")
	    @@sdl_audio = false
	end
    end
end
