# Scotty TNG - ping/snmp based realtime network monitoring
#
# $Id: drbd.rb 140 2008-10-08 21:04:31Z liske $
#
# Authors:
#   Thomas Liske <liske@ibh.de>
#   Andre Ellguth <ellguth@ibh.de>
#
# Copyright Holder:
#   2008 (C) IBH IT-Service GmbH [http://www.ibh.de/]
#
# License:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this package; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#

require 'drbfire.rb'
require 'rinda/ring'
require 'rinda/tuplespace'
require 'zlib'

# dRuby initialization
class ScottyTNG
  attr_reader :views, :graphs

  def self.initTS
    @@ts = Rinda::TupleSpace.new
  end

  def self.getTS
    return @@ts
  end

  def initialize(uri)
    DRb.start_service uri, @@ts, {DRbFire::ROLE => DRbFire::SERVER}
    puts DRb.uri

    # Start RingServer
    Rinda::RingServer.new ScottyTNG.getTS

    @@ts.write [:ScottyTNGd, `hostname`.chomp, Zlib::Deflate.deflate(IO.read("config/views.xml"), Zlib::BEST_COMPRESSION)]
  end
end

ScottyTNG.initTS
